#include <stdio.h>
#include <math.h>

#define SIZE 1000

void checkprime(int prime[], int size, int end);
void checkprimereverse(int prime[], int size, int type) ;
void printprime(int data[], int n);

int main(void)
{
	int i, prime[1001] = {0};

	for (i = 2; i <= SIZE; i++) prime[i] = 1;
	checkprime(prime, SIZE, 1);
	printprime(prime, SIZE); 

	for (i = 2; i <= SIZE; i++) prime[i] = 1;
	checkprime(prime, SIZE, 2);
	printprime(prime, SIZE);

	for (i = 2; i <= SIZE; i++) prime[i] = 1;
	checkprime(prime, SIZE, 3);
	printprime(prime, SIZE);

	for (i = 2; i <= SIZE; i++) prime[i] = 1;
	checkprimereverse(prime, SIZE, 1);
	printprime(prime, SIZE);

	for (i = 2; i <= SIZE; i++) prime[i] = 1;
	checkprimereverse(prime, SIZE, 2);
	printprime(prime, SIZE);

	for (i = 2; i <= SIZE; i++) prime[i] = 1;
	checkprimereverse(prime, SIZE, 3);
	printprime(prime, SIZE);

	return 0;
}

void checkprime(int prime[], int size, int type) {
	int i, divisor, end;

	//3 size 
	for (i = 3; i <= size; i++) {
		if (type == 1) end = i;
		else if (type == 2) end = i/2;
		else end = (int) sqrt(i);

		//2 end   Ҽ ƴ 
		for (divisor = 2; divisor <= end; divisor++)
			if ((divisor < i) && (i%divisor == 0)) prime[i] = 0;
	}
}

void checkprimereverse(int prime[], int size, int type) {
	int i, divisor, end;

	//3 size 
	for (i = 3; i <= size; i++) {
		if (type == 1) end = i;
		else if (type == 2) end = i/2;
		else end = (int) sqrt(i);

		//end 2   Ҽ ƴ 
		for (divisor = end; divisor >= 2; divisor--)
			if ((divisor != i) && (i%divisor == 0)) prime[i] = 0;
	}
}

void printprime(int data[], int n) 
{
	int i, count = 1;
	printf("1 %d  Ҽ(prime number)\n", n);
	for (i = 2; i <= n; i++)
		if (data[i] == 1)  
			printf("%3d%c", i, count++ == 20 ? (count = 1, '\n') : ' ');
	puts("");puts("");
}

/*
int isprime(int number) {
	int divisor;

	if (number >= 2)
	{
		if ( number == 2) 
			return 1;
		if ( number%2 == 0) 
			return 0;
		//3 n  Ȧ ,   ߴ  
		for (divisor = 3; number % divisor != 0; divisor += 2);
		//n   Ҽ̹Ƿ  
		if (divisor == number) {
			return 1;
		} else {
			return 0;
		}
	} else {
		return 0;
	}
}
*/

