#include <stdio.h>

#define rows 2
#define cols 3

typedef double matrixa[rows][cols];
typedef double matrixb[rows][cols];
typedef double resultc[rows][cols];

void plus(resultc r, matrixa a, matrixb b);
void minus(resultc r, matrixa a, matrixb b);
void display(resultc r, int m);
           
int main(void)
{
	matrixa a = {{4.2, 4.3, 3.8}, {3.7, 1.5, 0.7}};
	matrixb b = {{5.2, 2.1, 1.8}, {3.2, 1.4, 2.9}};
	resultc r = {0};

	display(a, rows);
	display(b, rows);

	printf("    ϱ Դϴ.\n\n");
	plus(r, a, b);
	display(r, rows);

    printf("     Դϴ.\n\n");
	minus(r, a, b);
	display(r, rows);

	return 0;
}

void plus(resultc r, matrixa a, matrixb b) {
	int i, j;

	for(i=0; i < rows ; i++) {
		for(j=0; j < cols ; j++) {
			//r[i][j] = a[i][j] + b[k][j];
			*(r[i]+j) = *(a[i]+j) + *(b[i]+j);  
		}
	}
}

void minus(resultc r, matrixa a, matrixb b) {
	int i, j;

	for(i=0 ; i< rows ; i++) {
		for(j=0 ; j < cols ; j++) {
			//r[i][j] = a[i][j] + b[k][j];
			*(r[i]+j) = *(a[i]+j) - *(b[i]+j);  
		}
	}
}

void display(resultc r, int m) {
	int i, j;
	for(i=0; i < m; i++) {
		for(j=0; j < cols; j++) {
			printf("%8.2f",r[i][j]);	
		}
		printf("\n");
	}
	printf("\n");
}
