
#include <stdio.h>

#define rows 2
#define cols 3

typedef double matrixa[rows][cols];
typedef double matrixb[cols][rows];
typedef double resultc[rows][rows];

void multiply(resultc r, matrixa a, matrixb b);
void display(resultc r, int m);

int main(void)
{
	matrixa a = {{4.2, 4.3, 3.8}, {3.7, 1.5, 0.7}};
	matrixb b = {{5.2, 2.1}, {3.2, 1.4}, {1.5, 3.6}};
	resultc r = {0};

	int i, j;
	for(i=0 ; i < rows; i++) {
		for(j=0 ; j < cols; j++) {
			printf("%8.2f", a[i][j]);
		}
		printf("\n");
	}
	printf("\n");

	display(b, cols);

	printf("     Դϴ.\n\n");
	multiply(r, a, b);
	display(r, rows);

	return 0;
}

void multiply(resultc r, matrixa a, matrixb b) {
	int i, j, k;

	for(i=0; i < rows ; i++) {
		for(j=0; j < rows ; j++) {
			for(k=0; k < cols; k++) {
				//r[i][j] += a[i][k] * b[k][j];
				*(r[i] + j) += *(a[i] + k)* *(b[k] + j);
			}
		}
	}
}

void display(resultc r , int m) {
	int i, j;

	for(i=0; i<m; i++) {
		for(j=0; j<rows; j++) {
			printf("%8.2f", r[i][j]);			
		}
		printf("\n");
	}
	printf("\n");
}
