#include <stdio.h>

int getTotalDates(int year, int month);
int getDay(int dates);

int main(void)
{
	int year, month, date, day;
	int totalDates;
	char *EDAY[] = {"SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT"}; 
	char *KDAY[] = {"", "", "ȭ", "", "", "", ""}; 

	printf(" ˰  ¥ Էϼ. (Է >> 2008 10 20)\n");
	scanf("%d %d %d", &year, &month, &date);

	totalDates = getTotalDates(year, month);

	//printf("%5d⵵ %2d   %5dԴϴ.\n", year, month, totalDates);

	day = getDay(totalDates + date);
	printf("%5d %2d %d  %d̸ %s(%s)Դϴ.\n", year, month, date, totalDates + date, KDAY[day], EDAY[day]);

	return 0;
}

int getTotalDates(int year, int month)
{
	int i;
	int totalDates = 0;

	int maxDayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	for (i = 1; i < year; i++)
	{
		if ((i % 4 == 0) && (i % 100 != 0) || (i % 400 == 0))
			totalDates += 366;
		else 
			totalDates += 365;
	}

	for (i = 1; i < month; i++)
	{
		totalDates += maxDayMonth[i-1];
		if (i == 2)
			if ((year%4 == 0) && (year%100 != 0) || (year%400 == 0))
				totalDates++;
	}

	return totalDates;
}

int getDay(int dates)
{
	return dates % 7;
}
