/* file : card2.h */

#include <stdlib.h>
#include <time.h>

#define NUMOFGAMER 5

enum enumsuit {Dia,Clb,Hrt,Spd};
enum enumface {Deuce,Three,Four,Five,Six,Seven,Eight,Nine,Ten,Jack,Queen,King,Ace};
enum rank {None,Onepair,Twopair,Triple,Straight,Flush,Fullhouse,Fourcard,Straightflush,RoyalSF};

typedef enum enumsuit est;
typedef enum enumface efc;
typedef enum rank rank;

struct card {
	est sut;
	efc fce;
};
typedef struct card card;

//char *ssut[] = {"Diamond", "Club", "Heart", "Spade"};
//char *sfce[] = {"(2)","(3)","(4)","(5)","(6)",
//                "(7)","(8)","(9)","(10)","Jack","Queen","King","Ace"};

char *sfce[] = { "1", "2", "3", "4", "5", "6", 
                    "7", "8", "9", "10", "11", "12", "13"};
char *ssut[] = { "(Hearts)", "(Diamonds)", "(Clubs)", "(Spades)"};
char *srank[] = {"None", "One pair", "Two pair", "Triple", "Straight", "Flush",
			     "Full house", "Four card", "Straight flush", "Royal straight flush"};

struct gambler {
	card cd[7];
	rank rk;
};
				
typedef struct gambler gambler;

void fdk(card *);
void sfl(card *);
void del(card *, gambler *gamer);
void print2card(gambler *);
void printcard(gambler *);
void printrank(gambler *gamer); // ϰ ڸ 
void srt(card *);
void swap(card *,card *);

int checkrank(card *x);
int isstraight(card *x); //ƮƮ ˻
