#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define SIZE 1000

void checkprime(int prime[], int size, int end);
void checkprimereverse(int prime[], int size, int type) ;
void printprime(int data[], int n, FILE *);

int main(void)
{
	int i, prime[1001] = {0};
	FILE *f;

	for (i = 2; i <= SIZE; i++) prime[i] = 1;
	checkprime(prime, SIZE, 1);

	if (fopen_s(&f, "prime.txt", "w") != 0) 
	{
		puts("  ʽϴ.");
		exit(0);
	};

	printprime(prime, SIZE, f); 


	return 0;
}

void checkprime(int prime[], int size, int type) {
	int i, divisor, end;

	//3 size 
	for (i = 3; i <= size; i++) {
		if (type == 1) end = i;
		else if (type == 2) end = i/2;
		else end = (int) sqrt(i);

		//2 end   Ҽ ƴ 
		for (divisor = 2; divisor <= end; divisor++)
			if ((divisor < i) && (i%divisor == 0)) prime[i] = 0;
	}
}

void checkprimereverse(int prime[], int size, int type) {
	int i, divisor, end;

	//3 size 
	for (i = 3; i <= size; i++) {
		if (type == 1) end = i;
		else if (type == 2) end = i/2;
		else end = (int) sqrt(i);

		//end 2   Ҽ ƴ 
		for (divisor = end; divisor >= 2; divisor--)
			if ((divisor != i) && (i%divisor == 0)) prime[i] = 0;
	}
}

void printprime(int data[], int n, FILE *f) 
{
	int i, count1 = 1, count2 = 1;
	printf("1 %d  Ҽ(prime number)\n", n);
	for (i = 2; i <= n; i++)
		if (data[i] == 1)  
		{
			printf("%3d%c", i, count1++ == 20 ? (count1 = 1, '\n') : ' ');
			fprintf(f, "%3d%c", i, count2++ == 20 ? (count2 = 1, '\n') : ' ');
		}
	puts("");puts("");
}

/*
int isprime(int number) {
	int divisor;

	if (number >= 2)
	{
		if ( number == 2) 
			return 1;
		if ( number%2 == 0) 
			return 0;
		//3 n  Ȧ ,   ߴ  
		for (divisor = 3; number % divisor != 0; divisor += 2);
		//n   Ҽ̹Ƿ  
		if (divisor == number) {
			return 1;
		} else {
			return 0;
		}
	} else {
		return 0;
	}
}
*/

