#include <stdio.h>
#include <stdlib.h>

struct node {
   int data;
   struct node *link;
};
typedef struct node node;

node * createNode(int n);
int printList(node *head);

int main(void) 
{
	int i;
	node *head = NULL;
	node *tail = NULL;

	for (i=0; i<5;i++) 
	{
		if (head == NULL) 
		{
			head = createNode((i+1)*(i+1));
			tail = head; 
		}
		else 
		{
			tail->link = createNode((i+1)*(i+1));
			tail = tail->link;
		}
	}
   	
	printList(head);

	return 0;
}

//带 ϴ Լ
node * createNode(int n)
{
	node *cur;
	cur = (node *) malloc(sizeof(node));
	if (cur == NULL) 
	{
		printf("   ޸ Ҵ翡  ֽϴ.\n");
		return NULL;
	}
	cur->data = n;
	cur->link = NULL;

	return cur;
}

// Ʈ    Լ
int printList(node *head) 
{
	int cnt = 0;
	node *nextNode = head;
	while (nextNode != NULL) 
	{
		printf("%d °  %d\n", ++cnt, nextNode->data);
		nextNode = nextNode->link;	    
	}

	return cnt;
}