#include <stdio.h>

#define ROWS 3
#define COLS 2

typedef int scalar;
typedef scalar matrix1[ROWS][COLS];
typedef scalar matrix2[COLS][ROWS];
typedef scalar result[ROWS][ROWS];

void multiply(result r, matrix1 a, matrix2 b);
void display(result r);

int main(void)
{
    matrix1 a = {{3, 5}, {4, 2}, {5, 7}};
    matrix2 b = {{3, 8, 2}, {2, 4, 6}};
    result r = {0};

	//display(r);
	multiply(r, a, b);
	display(r);

    return 0;
}

void multiply(result r, matrix1 a, matrix2 b) {
	int i, j, k;
	for (i=0; i < ROWS; i++) {
		for (j=0; j < ROWS; j++) {
			for (k=0; k < COLS; k++) {
				r[i][j] += a[i][k] * b[k][j];
			}
		}
	}
}

void display(result r) {
	int i, j;
	for (i=0; i < ROWS; i++) {
		for (j=0; j < ROWS; j++) {
			printf("%4d", r[i][j]);
		}
		printf("\n");
	}
	printf("\n");
}
