/****
 processfrequency.c : 迭     Ƚ ϰ 
                       ߿      
 ****/ 

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define SIZE 80
#define MAX 10

void mean(int [] );
void mode(int [], int []) ;
void printArray(int []);

int main()
{
	int frequency[10] = { 0 };
	int response[SIZE] = { 0 };
	int i;
	long seed;

	seed = time(NULL);
	srand(seed);
	for (i = 0; i < SIZE; i++) 
	{
		response[i] = rand()%MAX;
	}

	printArray(response);
	mean(response);
	mode(frequency, response);

	return 0;
}

//////////////////////////////////////////////////
void printArray(int a[])
{
   int j;
   printf("  0 9  \n");
   for (j = 0; j < SIZE; j++) 
   {
      if (j%20 == 0) printf( "\n" );
      printf("%2d", a[j]);
   }
   printf("\n\n");
}

//////////////////////////////////////////////////
void mean(int answer[])
{
   int j, total = 0;

   printf("%s\n%s\n%s\n", "********", "  ", "********");
   for (j = 0; j < SIZE; j++) total += answer[j];
   printf( "迭   ϷѴ.\n迭   %d̰ 迭  ü  %d̹Ƿ"
		   "\n %.4f ̴.\n", SIZE, total, (double) total / SIZE );
}

//////////////////////////////////////////////////
void mode(int freq[], int answer[])
{
   int rating, j, h, largest = 0, modeValue = 0;

   printf( "\n%s\n%s\n%s\n", "********", "  ", "********" );
   for ( rating = 0; rating <= 9; rating++ ) freq[rating] = 0;
   for ( j=0; j <= SIZE - 1; j++ ) ++freq[answer[j]];

   printf("-------------------------------------------------------\n");
   printf("%10s%10s%8s%-20s\n\n", "", "Ƚ", " ", "׷");
   printf("%28s%-40s\n%28s%-40s\n", " ", "         1    1    2    2", " ", "1   5    0    5    0    5" );
   printf("-------------------------------------------------------\n");

   for (rating = 0; rating <= 9; rating++)
   {
      printf("%10d%10d%8s", rating, freq[rating], " ");
      if (freq[rating] > largest)
	  {
         largest = freq[ rating ];
         modeValue = rating;
      }
      for (h = 1; h <= freq[rating]; h++) printf( "*" );
      printf( "\n" );
   }
   printf("-------------------------------------------------------\n");

   printf( "   Ƚ Ÿ.\nм ,   󵵼  "
		   "%d() %d Ÿ.\n", modeValue, largest );
}
/**************************************** α׷  *************************************************/