#include <stdio.h>
#include <math.h>

#define SIZE 1000

void printprime(int data[], int n);

int main(void)
{
	int i, j, limit;
	int prime[SIZE+1] = {0};

	for (i = 2; i <= SIZE; i++) prime[i] = 1;

	limit = (int) sqrt(SIZE);
	for (i = 2; i <= limit; i++) 
	{
		if (prime[i]==1) {
			for (j=2*i; j<=SIZE; j++) 
				if (j%i == 0)
					prime[j] = 0;
		}
	}

	printprime(prime, SIZE+1);
	return 0;
}

void printprime(int data[], int n) 
{
	int i, count = 1;
	printf("1 %d  Ҽ(prime number)\n", n);
	for (i = 2; i <= n; i++)
		if (data[i] == 1)  
			printf("%3d%c", i, count++ == 20 ? (count = 1, '\n') : ' ');
	puts("");puts("");
}
