#include <stdio.h>

#define ROW 10

void pascaltriangle(int (*p)[ROW], int size);
void triangleprint(int (*p)[ROW], int size);

int main(void) 
{
	int pascal[10][10] = {0};
	pascaltriangle(pascal, ROW);
	triangleprint(pascal, ROW);

	return 0;
}

void pascaltriangle(int (*p)[ROW], int size)
{
	int i, j;
	for (i = 0; i < size; i++) 
	{
		for (j = 0; j <= i; j++) 
			if ((j == 0) || (j==i) )
				p[i][j] = 1;
			else 
				p[i][j] = p[i-1][j] + p[i-1][j-1];
	}
}
void triangleprint(int (*p)[ROW], int size)
{
	int i, j;
	for (i = 0; i < size; i++) 
	{
		for (j = 0; j <= i; j++) 
			printf("%d ", p[i][j]); 
		puts("");
	}
	puts("");
}