#include <stdio.h>

void arraymerge(int *a, int an, int *b, int bn, int *c);
void print(int *p, int size);

int main(void) 
{
	int a[] = {1, 2, 5, 7, 9, 14}; 
	int an = sizeof(a)/sizeof(a[0]);
	int b[] = {2, 3, 6, 8, 13};
	int bn = sizeof(b)/sizeof(b[0]);
	int c[20] = {0};

	arraymerge(a, an, b, bn, c);
	print(c, an+bn);

	return 0;
}

void arraymerge(int *a, int an, int *b, int bn, int *c)
{
	int i=0, j=0;
	while ( i < an && j < bn) 
		if (a[i] <= b[j]) 
			*c++ = a[i++];
		else 
			*c++ = b[j++];
	while (j < bn) *c++ = b[j++];
	while (i < an) *c++ = a[i++];		
}
void print(int *p, int size)
{
	int i;
	for (i = 0; i < size; i++) 
		printf("%d ", p[i]); 
	puts("");
}