////////////////////////////////////////////////////////////////////
/* file : card.c */

#include <stdio.h>
#include "card.h"

int main()
{ 
	card deck[52];
	int cnt = 2;

	filldeck(deck);
	shuffle(deck);
	printf("ī ӿ   մϱ? >> ");
	scanf("%d", &cnt);
	printf("\n");
	deal(deck, cnt);

	return 0;
}

void filldeck(card *deck)
{ 
	int i;
	for ( i = 0; i <= 51; i++ ) 
	{ 
	  deck[ i ].face = i % 13;  //1 king 
	  deck[ i ].suit = i / 13;  //hearts spades
	}
}

void shuffle(card *deck)
{ 
	int i, j;
	card temp;
	srand( time(NULL) );
	for ( i = 0; i <= 51; i++ ) 
	{ 
		j = rand() % 52;
		temp = deck[ i ];
		deck[ i ] = deck[ j ];
		deck[ j ] = temp;
	}
}

void deal(card *deck, int cnt)
{ 
	int i;
	int total = 7*cnt;
	for ( i = 0; i < cnt; i++ )
		printf( "%10s%-10d", " ", i+1);
	printf("\n");

	for ( i = 0; i < total; i++ )
		printf( "%3s of %-12s%c", strface[deck[i].face], 
		         strsuit[deck[i].suit], (i+1) % cnt ? '  ' : '\n');
}
////////////////////////////////////////////////////////////////////