#include <stdio.h>
#include <stdlib.h>

struct node {
   double data;
   struct node *link;
};
typedef struct node node;

node * createNode(double);
int printList(node *);
node * search(node *, double);

int main(void) 
{
	int i;
	node *head = NULL, *tail = NULL;
	node *cur = NULL; 

	head = createNode(0.5);
	tail = head; 
	for (i=1; i<5;i++) 
	{
		tail->link = createNode(i+0.5);
		tail = tail->link;
	}
	printList(head);
	cur = search(head, 3.5);
	printf("%.1f\n", cur->data);

	return 0;
}

// Ʈ head  data d 带 ã ȯϴ Լ
node * search(node *head, double d) 
{
	int cnt = 0;
	node *nextNode = head;
	while (nextNode == NULL || nextNode->data != d) 
	{
		printf("%d °  %.1f\n", ++cnt, nextNode->data);
		nextNode = nextNode->link;	    
	}

	return nextNode;
}

//带 ϴ Լ
node * createNode(double n)
{
	node *cur;
	cur = (node *) malloc(sizeof(node));
	if (cur == NULL) 
	{
		printf("   ޸ Ҵ翡  ֽϴ.\n");
		return NULL;
	}
	cur->data = n;
	cur->link = NULL;

	return cur;
}


// Ʈ    Լ
int printList(node *head) 
{
	int cnt = 0;
	node *nextNode = head;
	while (nextNode != NULL) 
	{
		printf("%d °  %.1f\n", ++cnt, nextNode->data);
		nextNode = nextNode->link;	    
	}

	return cnt;
}

